%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PC: BIG-FASLEND.SL
% Title:          Patch to FASLEND for huge files
% Author:         Eric Benson
% Created:        7 May 1982
% Modified:       06-Dec-83 10:00 (Brian Beach)
% Status:         Experimental
% Mode:           Lisp
% Package:        Compiler
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1982, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 06-Dec-83 10:00 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  <PSL.COMP>BIG-FASLEND.RED.4, 10-Jun-82 10:39:32, Edit by GRISS          
%  Added InitCodeMax!* for testing                                         
%                                                                          
(de compileuncompiledexpressions ()
  (errorprintf "%n*** Init code length is %w%n" 
               (length (car uncompiledexpressions!*)))
  (compileinitcode '!*!*fasl!*!*initcode!*!* (car uncompiledexpressions!*)))

(fluid '(initcodemax!*))

(loadtime
  (progn (setq initcodemax!* 350)))

(de compileinitcode (name initcodelist)
  (prog (x len lasthalf)
        (return (if (ilessp (setq len (length initcodelist)) initcodemax!*)
                  (dfprintfasl 
                   (list 'de name 'nil (cons 'progn initcodelist)))
                  (progn (errorprintf 
                          "*** Initcode length %w too large, splitting into smaller pieces"
                          len)
                         (errorprintf 
                          "*** Please use smaller files in FASL")
                         (setq x (pnth initcodelist (iquotient len 2)))
                         (setq lasthalf (cdr x))
                         (rplacd x nil)
                         % tricky, split the code in 2                     
                         (setq x 
                          (intern (concat (id2string name) (stringgensym))))
                         (flag1 x 'internalfunction)
                         % has to be internal to get called!               
                         (compileinitcode x initcodelist)
                         (compileinitcode name (cons (list x) lasthalf)))))))

% call previous                                                            
