%
% 370COMP.RED - Compiler patterns for IBM370 PSL, plus some cmacro expanders
%
% Author:      Jim McDonald
%              IMSSS
%              Stanford University
% Date:        29 January 1983
% Copyright (c) 1983 Stanford University
%

% Based on 20-COMP.RED, 11 January 1982 by BENSON
%       (which in turn is based on VAX version)
% Copyright (c) 1982 Eric Benson
% Copyright (c) 1983 Jim McDonald
%       Changed Wplus2 to load indexed addresses more efficiently.
%       Moved !*LAMBIND and !*JUMPON cmacros to 370-CMAC.RED


%  Machine-dependent part of !&PANonLocal (see complr.red)

(de &panonlocalsystemaux (x)            % in  COMP370.RED
      (list 'warray x))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                           %
%  Patterns defined here:                                                   %
%                                                                           %
%       TvPat, TvPat1, TstPat, TstPatC, TstPat2, SetqPat, RplacPat,         %
%       AssocPat, SubPat, NonAssocPat, FieldPat, PutFieldPat, UnaryPat,     %
%       ModMemPat, ModMemPat1,                                              %
%       Plus2Pat (new)                                                      %
%                                                                           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(put 'tvpat 'pattern 
    '(&regmem ('*destroy dest) 
    ((dest any) (mac l1 a1 a2) ('*load dest ''nil) 
                ('*jump l2) ('*lbl l1) ('*load dest ''t) ('*lbl l2)) 
    ((any dest) (mac l1 a1 a2) ('*load dest ''nil) 
                ('*jump l2) ('*lbl l1) ('*load dest ''t) ('*lbl l2)) 
    ((usesdest any) (mac l1 a1 a2) ('*load dest ''nil) 
                ('*jump l2) ('*lbl l1) ('*load dest ''t) ('*lbl l2)) 
    ((any usesdest) (mac l1 a1 a2) ('*load dest ''nil) 
                ('*jump l2) ('*lbl l1) ('*load dest ''t) ('*lbl l2)) 
    (any ('*load dest ''t) (mac l1 a1 a2) 
         ('*load dest ''nil) ('*lbl l1))))


(put 'tvpat1 'pattern 
    '(&regmem ('*destroy dest) 
    ((dest) (mac l1 a1 p2) ('*load dest ''nil) 
                ('*jump l2) ('*lbl l1) ('*load dest ''t) ('*lbl l2)) 
    ((usesdest) (mac l1 a1 p2) ('*load dest ''nil) 
                ('*jump l2) ('*lbl l1) ('*load dest ''t) ('*lbl l2)) 
    (any ('*load dest ''t) (mac l1 a1 p2) 
         ('*load dest ''nil) ('*lbl l1))))


(put 'tstpat 'pattern '(nil 
    
    &fixregtest 
    ((regn any) (mac dest a1 a2)) 
    (any (mac dest a2 a1))))

(put 'tstpatc 'pattern '(nil 
     
    &setregs1 
     ((regn any) (mac dest a1 a2)) 
     (any (p2 dest a2 a1))))

(put 'tstpat2 'pattern '(nil 
     &setregs1 
     (any (mac dest a1 p2))))

(put 'setqpat 'pattern '(nil nil 
 
 ((noval any notanyreg) ('*store a2 a1)) 
 ((noval dest any) ('*store a2 dest)) 
 ((noval usesdest any) ('*load t1 a2) ('*store t1 a1)) 
 ((noval any any) ('*load dest a2) ('*store dest a1)) 
 ((any dest) ('*store dest a1)) 
 ((dest any) ('*store a2 dest)) 
 ((usesdest any) ('*store a2 a1) ('*store a2 dest)) 
 (any ('*load dest a2) ('*store dest a1))))

(put 'rplacpat 'pattern '(nil nil 
   
   ((noval any any) ('*store a2 (mac a1))) 
   ((dest any) ('*store a2 (mac a1))) 
   ((usesdest any) ('*store a2 (mac a1)) ('*load dest a1)) 
   ((any dest) ('*store a2 (mac a1)) ('*load dest a1)) 
   ((any usesdest) ('*store a2 (mac a1)) ('*load dest a1)) 
   (any ('*load dest a1) ('*store a2 (mac dest)))))

(put 'assocpat 'pattern '(nil 
   ('*set dest (fn a1 a2)) 
  ((dest any) (mac a1 a2)) 
  ((any dest) (mac a2 a1)) 
  ((usesdest usesdest) ('*load t1 a1) ('*load dest a2) (mac dest t1)) 
  ((any usesdest) ('*load dest a2) (mac dest a1)) 
  (any ('*load dest a1) (mac dest a2))))

(put 'subpat 'pattern '(nil 
  ('*set dest (fn a1 a2)) 
   ((dest any) (mac a1 a2)) 
   ((any dest) ('*wminus dest dest) ('*wplus2 a2 a1)) 
   (any ('*load dest a1) (mac dest a2))))

(put 'nonassocpat 'pattern '(nil 
   ('*set dest (fn a1 a2)) 
   ((dest any) (mac a1 a2)) 
   ((any usesdest) ('*load t1 a2) ('*load dest a1) (mac dest t1)) 
   (any ('*load dest a1) (mac dest a2))))

(put 'fieldpat 'pattern '(nil 
   ('*set dest (fn a1 a2 a3)) 
   (any (mac dest a1 a2 a3))))

(put 'putfieldpat 'pattern '(nil nil 
   
   ((noval any any any any) (mac a1 a2 a3 a4)) 
   (any (mac a1 a2 a3 a4) ('*store a1 dest))))

(put 'unarypat 'pattern 
   '(&noanyreg ('*set dest (fn a1)) 
   (any (mac dest a1))))

(put 'modmempat 'pattern '(nil nil 
   
   (any (mac a1 a2))))

(put 'modmempat1 'pattern '(nil nil 
  
   (any (mac a1 a1))))

% following moved to 370-cmac-fns.sl
% symbolic procedure !&RealRegP U;                      % new for 370
% EqCar( U, 'Reg ) or
% ( PairP U and FlagP( Car U, 'Var ) and Get( cadr U, 'RegisterAlias ));

%  IBM 370 permits double-indexing, e.g.  123(R1,R2)
%  These modifications take advantage of that feature
(put 'realreg 'matchfn '&realregp)      % new for 370
(put 'dispwconst 'matchfn '&dispwconstp)% new for 370
% put( 'WConst,   'MatchFn, '!&WConstP );               % new for 370
% put( 'WPlus2,     'OpenFn,  '(Plus2Pat !*WPlus2));    % changed for 370

(put 'plus2pat 'pattern '(nil 
  ('*set dest (fn a1 a2)) 
  ((dest any) (mac a1 a2)) 
  ((any dest) (mac a2 a1)) 
  ((usesdest usesdest) ('*load t1 a1) ('*load dest a2) (mac dest t1)) 
  ((any usesdest) ('*load dest a2) (mac dest a1)) 
  ((realreg dispwconst) ('*load dest ('address a1 a2))) 	% new case for 370
  ((dispwconst realreg) ('*load dest ('address a2 a1))) 	% new case for 370
  (any ('*load dest a1) (mac dest a2))))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  The following floating point macros may expand to a constant,           %
%  to non-branching opencode, or to a call to a closed function.           %
%                                                                          %
%  If the program logic needed to implement the desired operation requires %
%  a branch, then on the 370 a label will be needed.  Unless the open      %
%  functions were done more elaborately than the normal mechanism provides %
%  for, this would preclude two uses of any such open function inside one  %
%  context.  (To prevent the same label from occurring more than once.)    %
%  That is the only reason closed functions are invoked.                   %
%                                                                          %
%  In the following diagram, the macro invoked may generate a constant     %
%  or a call to a closed or open-coded function, desgined to handle short  %
%  (4 byte), long (8 byte), or extended (16 byte) floating point numbers.  %
%  `...' represents `Short', `Long', or `Extended'.                        %
%                                                                          %
%   macro invoked      invokes opencode fn      calls closed fn            %
%   -------------      -------------------  or  ----------------           %
%                                                                          %
%   !*WFix                                      ...FloatWFix               %
%   !*WFloat                                    ...FloatWFloat             %
%   !*FEQ                                       ...FloatEQ                 %
%   !*FGreaterP                                 ...FloatGreaterP           %
%   !*FLessP                                    ...FloatLessP              %
%                                                                          %
%   !*FAssign          ...FloatAssign                                      %
%   !*FPlus2           ...FloatPlus2                                       %
%   !*FDifference      ...FloatDifference                                  %
%   !*FTimes2          ...FloatTimes2                                      %
%   !*FQuotient        ...FloatQuotient                                    %
%                                                                          %
%   Note:  ExtendedFloatQuotient always yields 0 in 3rd and 4th words,     %
%          since there is no machine instruction for extended division.    %
%          (This could be improved with slightly more complex code.)       %
%                                                                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(fluid '(floatmode*))                   % controls choice of floating point arithmetic
% pick one -- anything other than Short or Extended is treated as Long
  (setq floatmode* 'long)
% FloatMode!* := 'Short;
% FloatMode!* := 'Extended;

%  These generate calls to ...Float... functions,
%   defined in <IBM>CMSFLOAT.ASSEMBLE

(dm *wfix (x) 
% if NumberP caddr X then list( 'setq, cadr x, list( 'Fix, caddr x ))
% else
 (cons (cond ((equal floatmode* 'short) 'shortfloatfix) (t 'longfloatfix)) 
       % no need for ExtendedFloatFix, only first 2 words are relevent
       (cdr x)))

(dm *wfloat (x) 
% if NumberP caddr X then list( '!*FAssign, cadr x, list( 'Float, caddr x ))
% else
 (cons (cond ((equal floatmode* 'short) 'shortfloatwfloat) 
       ((equal floatmode* 'extended) 'extendedfloatwfloat) (t 
                                       'longfloatwfloat)) 
       (cdr x)))

(dm *feq (x) 
 (cond ((equal (cadr x) (caddr x)) t) 
 ((and (numberp (cadr x)) (numberp (caddr x))) nil) (t 	% since not equal
 (cons (cond ((equal floatmode* 'short) 'shortfloateq) 
            ((equal floatmode* 'extended) 'extendedfloateq) (t 
                                            'longfloateq)) 
            (cdr x)))))

(dm *fgreaterp (x) 
 (cond ((equal (cadr x) (caddr x)) nil) 
 ((and (numberp (cadr x)) (numberp (caddr x))) (greaterp (cadr x) (caddr x))) (t 
 (cons (cond ((equal floatmode* 'short) 'shortfloatgreaterp) 
            ((equal floatmode* 'extended) 'extendedfloatgreaterp) (t 
                                            'longfloatgreaterp)) 
            (cdr x)))))

(dm *flessp (x) 
 (cond ((equal (cadr x) (caddr x)) nil) 
 ((and (numberp (cadr x)) (numberp (caddr x))) (lessp (cadr x) (caddr x))) (t 
 (cons (cond ((equal floatmode* 'short) 'shortfloatlessp) 
            ((equal floatmode* 'extended) 'extendedfloatlessp) (t 
                                            'longfloatlessp)) 
            (cdr x)))))


%  these call open-coded functions defined below

(dm *fassign (x) 
 (cons (cond ((equal floatmode* 'short) 'shortfloatassign) 
       ((equal floatmode* 'extended) 'extendedfloatassign) (t 
                                       'longfloatassign)) 
       (cdr x)))

(dm *fplus2 (x) 
 (cond ((and (numberp (cadr x)) (numberp (caddr x))) (plus (cadr x) (caddr x))) (t 
 (cons (cond ((equal floatmode* 'short) 'shortfloatplus2) 
            ((equal floatmode* 'extended) 'extendedfloatplus2) (t 
                                            'longfloatplus2)) 
            (cdr x)))))

(dm *fdifference (x) 
 (cond ((and (numberp (cadr x)) (numberp (caddr x))) (difference (cadr x) (caddr x))) (t 
 (cons (cond ((equal floatmode* 'short) 'shortfloatdifference) 
            ((equal floatmode* 'extended) 'extendedfloatdifference) (t 
                                            'longfloatdifference)) 
            (cdr x)))))

(dm *ftimes2 (x) 
 (cond ((and (numberp (cadr x)) (numberp (caddr x))) (times (cadr x) (caddr x))) (t 
 (cons (cond ((equal floatmode* 'short) 'shortfloattimes2) 
            ((equal floatmode* 'extended) 'extendedfloattimes2) (t 
                                            'longfloattimes2)) 
            (cdr x)))))

(dm *fquotient (x) 
 (cond ((and (numberp (cadr x)) (numberp (caddr x))) (quotient (cadr x) (caddr x))) (t 
 (cons (cond ((equal floatmode* 'short) 'shortfloatquotient) 
            ((equal floatmode* 'extended) 'extendedfloatquotient) (t 
                                            'longfloatquotient)) 
            (cdr x)))))


(deflist '((f0 f0) (f2 f2) (f4 f4) (f6 f6)) 'registername)


(deflist 

 % FAssign - copy number pointed by R2 to place where R1 points

 '((shortfloatassign 
   ((mvc (lengthbased 4 (indexed (reg 1) 0)) (indexed (reg 2) 0)))) 

 (longfloatassign 
   ((mvc (lengthbased 8 (indexed (reg 1) 0)) (indexed (reg 2) 0)))) 

 (extendedfloatassign 
   ((mvc (lengthbased 16 (indexed (reg 1) 0)) (indexed (reg 2) 0)))) 

 % FPlus2 - add number pointed at by R2 to number pointed at by R3
 %           and store result where R1 points

 (shortfloatplus2 
   ((le (reg f0) (indexed (reg 2) 0)) 
    (ae (reg f0) (indexed (reg 3) 0)) 
    (ste (reg f0) (indexed (reg 1) 0)))) 

 (longfloatplus2 
   ((ld (reg f0) (indexed (reg 2) 0)) 
    (ad (reg f0) (indexed (reg 3) 0)) 
    (std (reg f0) (indexed (reg 1) 0)))) 

 (extendedfloatplus2                    % note: can only add-extended from regs
   ((ld (reg f0) (indexed (reg 2) 0))   % load first half of first arg
    (ld (reg f2) (indexed (reg 2) 8))   % load second half of first arg
    (ld (reg f4) (indexed (reg 3) 0))   % load first half of second arg
    (ld (reg f6) (indexed (reg 3) 8))   % load second half of second arg
    (axr (reg f0) (reg f4))             % add-extended
    (std (reg f0) (indexed (reg 1) 0))  % store first half of result
    (std (reg f2) (indexed (reg 1) 8)))) 	% store second half of result


 % FDifference - subtract number pointed at by R3 from number pointed at
 %                by R2 and store result where R1 points

 (shortfloatdifference 
   ((le (reg f0) (indexed (reg 2) 0)) 
    (se (reg f0) (indexed (reg 3) 0)) 
    (ste (reg f0) (indexed (reg 1) 0)))) 

 (longfloatdifference 
   ((ld (reg f0) (indexed (reg 2) 0)) 
    (sd (reg f0) (indexed (reg 3) 0)) 
    (std (reg f0) (indexed (reg 1) 0)))) 

 (extendedfloatdifference               % note: can only subtract-extended from regs
   ((ld (reg f0) (indexed (reg 2) 0))   % load first half of first arg
    (ld (reg f2) (indexed (reg 2) 8))   % load second half of first arg
    (ld (reg f4) (indexed (reg 3) 0))   % load first half of second arg
    (ld (reg f6) (indexed (reg 3) 8))   % load second half of second arg
    (sxr (reg f0) (reg f4))             % subtract-extended
    (std (reg f0) (indexed (reg 1) 0))  % store first half of result
    (std (reg f2) (indexed (reg 1) 8)))) 	% store second half of result

 % FTimes2 - mulitply number pointed at by R2 with number pointed at by R3
 %            and store result where R1 points

 (shortfloattimes2 
   ((le (reg f0) (indexed (reg 2) 0)) 
    (me (reg f0) (indexed (reg 3) 0)) 
    (ste (reg f0) (indexed (reg 1) 0)))) 

 (longfloattimes2 
   ((ld (reg f0) (indexed (reg 2) 0)) 
    (md (reg f0) (indexed (reg 3) 0)) 
    (std (reg f0) (indexed (reg 1) 0)))) 

 (extendedfloattimes2                   % note: can only multiply-extended from regs
   ((ld (reg f0) (indexed (reg 2) 0))   % load first half of first arg
    (ld (reg f2) (indexed (reg 2) 8))   % load second half of first arg
    (ld (reg f4) (indexed (reg 3) 0))   % load first half of second arg
    (ld (reg f6) (indexed (reg 3) 8))   % load second half of second arg
    (mxr (reg f0) (reg f4))             % multiply-extended
    (std (reg f0) (indexed (reg 1) 0))  % store first half of result
    (std (reg f2) (indexed (reg 1) 8)))) 	% store second half of result

 % FQuotient - divide number pointed at by R2 with number pointed at by R3
 %              and store result where R1 points

 (shortfloatquotient 
   ((le (reg f0) (indexed (reg 2) 0)) 
    (de (reg f0) (indexed (reg 3) 0)) 
    (ste (reg f0) (indexed (reg 1) 0)))) 

 (longfloatquotient 
   ((ld (reg f0) (indexed (reg 2) 0)) 
    (dd (reg f0) (indexed (reg 3) 0)) 
    (std (reg f0) (indexed (reg 1) 0)))) 

 (extendedfloatquotient                 % note: there is no divide-extended instruction
   ((ld (reg f0) (indexed (reg 2) 0))   % load 1st half of 1st arg
    (dd (reg f0) (indexed (reg 3) 0))   % divide-long by 1st half of 2nd arg
    (std (reg f0) (indexed (reg 1) 0))  % store as 1st half of result
    (mvc (lengthbased 8 (indexed (reg 1) 8)) (lit (fullword 0)))))) 
                                         % 2nd half of result := 0  (kludge)

 'opencode)





