#! /bin/csh

#
#   Generate PSL kernel Assembler modules from LISP sources
#


# $psys/psl >>mkkern.lst  <<EOF


$psys/psl  <<EOF

(load addr2id)
 
(load useful) (load strings)
(off usermode)

(load compiler)

 
(off lapopt)

(load fasl-decls 
      f-strings 
      f-vectors 
      hash-decls 
      sys-consts
      lap-to-asm
      convex-asm)

(de readsymfile() nil)
(de writesymfile() nil)

(off echo)
 


(on fast-integers fast-strings)
 
 
(de hugo ()(terpri) (terpri)(prin2t "##### NIL was called as function"))
(copyd 'bstackoverflow 'external_exit)   

(copyd 'nil 'hugo)

(de anyreglabelgen (reg name)
  ((lambda (lb al)
           (cond ((null al)
                  (setq labelgen* (cons (cons name lb) labelgen*)))
                 (t (rplacd al lb)))
           lb)
   (gensym)
   (assoc name labelgen*)))
 
(de labelref (name) (list (anyreglabelref nil name)))


 
(setq macro 'macro)
 
(putd 'idloc macro (quote (lambda (x) (findidnumber (cadr x)))))


% restore mkitem
(remd 'mkitem)
(put 'mkitem 'PASS-1-MACRO 'PA1M-MKITEM)


(setq modname* '_!p!s!l_!m!a!i!n)
(setq *immediatequote T)



(asmout "main")
 
(dskin "$pk/firstkernel.sl")
(dskin "$pxk/externals.sl")
(dskin "$pxk/main-start.sl")
(dskin "$pxk/io.sl")
(dskin "$pk/alloc.sl")
(dskin "$pxk/intern.sl")
(dskin "$pxk/faslin.sl")
(dskin "$pk/support.sl")
(dskin "$pxk/sys-support.sl")
(dskin "$pk/lastkernel.sl")

(asmend)
 
(quit)

EOF
 
