%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXNK:WFLOAT.SL
% Description:  Interface to foreign floating point functions.             
% Author:       RAM, HP/FSD                                                
% Created:      27-Feb-84                                                  
% Modified:     29-Oct-84 09:06:40 (Vicki O'Day)
% Mode:         Lisp                                                       
% Package:                                                                 
% Status:       Experimental (Do Not Distribute)                           
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.        
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions
%
% 04-Apr-87 (Leigh Stoller)
%  Added support for 68020 IEEE negative zero test. See $pnk/arithmetic.sl.
% 29-Oct-86 (Leigh Stoller)
%  Removed definition of writefloat. It has been returned to write-float.sl.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(fluid '(**neg-zero** **neg-one**))

(off echo)

(de *wfloat (x y)
  (uxfloat (mkvec x) y))

(de *fplus2 (x y z)
  (when (eq -1 (uxplus2 (mkvec x) (mkvec y) (mkvec z)))
      (error 4712 "Floating point Exception")))

(de *fdifference (x y z)
  (when (eq -1 (uxdifference (mkvec x) (mkvec y) (mkvec z)))
      (error 4712 "Floating point Exception")))

(de *ftimes2 (x y z)
  (when (eq -1 (uxtimes2 (mkvec x) (mkvec y) (mkvec z))) 
      (error 4712 "Floating point Exception")))

(de *fquotient (x y z)
  (when (eq -1 (uxquotient (mkvec x) (mkvec y) (mkvec z)))
      (error 4712 "Floating point Exception")))

(de *fgreaterp (x y)
  (uxgreaterp (mkvec x) (mkvec y) 't 'nil))

(de *flessp (x y)
  (uxlessp (mkvec x) (mkvec y) 't 'nil))

(de *wfix (x)
     (uxfix (mkvec x)))

(de *fassign (x y)
  (uxassign (mkvec x) (mkvec y)))

(de *doubletofloat (x y)
  (uxdoubletofloat (mkvec x) (mkvec y)))

% These two statements must be at the end of the file because times2, and
% thus *ftimes2, must be defined before it is used.

(loadtime (progn
	    (setq **neg-one** -1.0)
   	    (setq **neg-zero** (times2 **neg-one** 0.0))))

% For DCM                                                                  
(de *floattodouble (x y)
  (uxfloattodouble (mkvec x) (mkvec y)))
