%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXNK:TIMC.SL
% Description:  Get run time in milliseconds.                              
% Author:       W. Neun, H. Melenk
% Created:      22-Dec-86
% Package:      
% RCS $Header: $
%
% (c) Copyright 1990, Konrad-Zuse-Zentrum Berlin.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Revisions:
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime (load sys-macros))

(compiletime (flag '(internal-time) 'internalfunction)) 

(fluid '(**windows))

(declare-warray timebuffer size 6) %0:3 used for external_timc
                                   %  4 accumulated system time
                                   %  5 temporary value

(setf (wgetv timebuffer 4) 0)
(setf (wgetv timebuffer 5) 0)

% Get run-time in milliseconds. 

(de time() 
  (sys2int 
    (wtimes2 10 
      (wdifference (timc) (wgetv timebuffer 4))
      )))

(de &time-control(mode)
  % nil: start system time
  % t:   start user time
  % -1:  reset timing
  (cond ((eq mode -1) (setf (wgetv timebuffer 4) (timc)))
        (mode
            (setf (wgetv timebuffer 4)
                  (wplus2 (wgetv timebuffer 4)
                          (wdifference (timc) (wgetv timebuffer 5)) )))
        (t (setf (wgetv timebuffer 5) (timc)))
))

% Get system time in 1/100 seconds.

(de timc () 
 (if (weq **windows 1) 
     (wquotient (psll-call 0 0 0 13) 10)
     (progn 
        (external_timc timebuffer)
        (wgetv timebuffer 0))))

(off fast-integers)
