%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File:  DISASSEMBLE -  disassembler for Cray Psl
%
% Author: H. Melenk , ZIB Berlin
%
% Date : 25-May-86
%
% Copyright (c) 1987,1988 Konrad Zuse Zentrum Berlin, all rights reserved
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Revisions:
%
% 7-March 1988 W. Neun
% Introduced the Y-MP (3 parcel) instructions
 
(compiletime (load huge-frame fast-vector big-faslend if-system))
 
(compiletime (setq *syslisp t))
 
(fluid '(code-sequence* code-sequencei0k* code-sequenceij0*
         code-sequencePat* options*))
 
(de anyp (x) t)
 
(de emap (i) (wgreaterp i 3)) % for EMA machines
 
(de safe-int2id(x)
     (cond ((not (posintp x)) (mkid 32))
           ((and (not (memq 'double-symbol-space options*))
                 (wgreaterp x maxsymbols)) (mkid 32))
           ((wgreaterp x (wlshift maxsymbols 1)) (mkid 32))
           ((stringp (symnam x)) (mkid x))
           (t (mkid 32))))
 
(setq code-sequence*    (mkvect 127))
(setq code-sequencei0k* (mkvect 127))
(setq code-sequenceij0* (mkvect 127))
(setq code-sequencepat* (mkvect 127))
 
 %%%% instructions
 
(putv code-sequencepat* 8#002 '(
   ((eq4p zerop zerop)          ("DRI"))
   ((eq3p zerop zerop)          ("ERI"))
   ((zerop zerop zerop)         ("VL" t1 "0"))
   ((zerop zerop anyp)          ("VL" t1 "A" k)) ))
(putv code-sequencepat* 8#003 '(
   ((zerop zerop zerop)         ("VM" t1 "0"))
   ((zerop anyp  zerop)         ("VM" t1 "S" j))
   ((eq4p  anyp  anyp )         ("SM" j k t1  "1,TS" ))
   ((eq6p  anyp  anyp )         ("SM" j k t1  "0" ))
   ((eq7p  anyp  anyp )         ("SM" j k t1  "1" )) ))
    % jump instrs
(putv code-sequence* 8#004 '("EX"   t1 i j k    ))
(putv code-sequence* 8#005 '("J"    t1 "B" j k    ))
(putv code-sequence* 8#006 '("J"    t1 label))
(putv code-sequence* 8#007 '("R"    t1 label))
(if_system Y-MP
(progn   % No EMA insructions on Y-MP
(putv code-sequence* 8#010 '("JAZ" t1 label))
(putv code-sequence* 8#011 '("JAN" t1 label))
(putv code-sequence* 8#012 '("JAP" t1 label))
(putv code-sequence* 8#013 '("JAM" t1 label))
(putv code-sequence* 8#014 '("JSZ" t1 label))
(putv code-sequence* 8#015 '("JSN" t1 label))
(putv code-sequence* 8#016 '("JSP" t1 label))
(putv code-sequence* 8#017 '("JSM" t1 label)))
(progn  % X-MP
(putv code-sequencepat* 8#010 '(
   ((emap anyp anyp)       ("A0"  t1 emamem t2 comment))
   ((anyp anyp anyp)       ("JAZ" t1 label)) ))
(putv code-sequencepat* 8#011 '(
   ((emap anyp anyp)       ("A1"  t1 emamem t2 comment))
   ((anyp anyp anyp)       ("JAN" t1 label)) ))
(putv code-sequencepat* 8#012 '(
   ((emap anyp anyp)       ("A2"  t1 emamem t2 comment))
   ((anyp anyp anyp)       ("JAP" t1 label)) ))
(putv code-sequencepat* 8#013 '(
   ((emap anyp anyp)       ("A3"  t1 emamem t2 comment))
   ((anyp anyp anyp)       ("JAM" t1 label)) ))
(putv code-sequencepat* 8#014 '(
   ((emap anyp anyp)       ("A4"  t1 emamem t2 comment))
   ((anyp anyp anyp)       ("JSZ" t1 label)) ))
(putv code-sequencepat* 8#015 '(
   ((emap anyp anyp)       ("A5"  t1 emamem t2 comment))
   ((anyp anyp anyp)       ("JSN" t1 label)) ))
(putv code-sequencepat* 8#016 '(
   ((emap anyp anyp)       ("A6"  t1 emamem t2 comment))
   ((anyp anyp anyp)       ("JSP" t1 label)) ))
(putv code-sequencepat* 8#017 '(
   ((emap anyp anyp)       ("A7"  t1 emamem t2 comment))
   ((anyp anyp anyp)       ("JSM" t1 label)) ))))
 
    % load address
(putv code-sequence* 8#020 '("A" i t1     mem   t2 label comment))
(putv code-sequence* 8#021 '("A" i t1 "-" memp1 t2 comment))
(putv code-sequence* 8#022 '("A" i t1 j k))
    % register transp
(putv code-sequence*    8#023 '("A" i t1 "S" j       ))
(putv code-sequence*    8#024 '("A" i t1 "B" j k t2 breg    ))
(putv code-sequence*    8#025 '("B" j k t1 "A" i t2 breg    ))
(putv code-sequencepat* 8#026 '(
   ((anyp anyp  zerop)         ("A" i t1 "PS" j))
   ((anyp anyp  eq1p)          ("A" i t1 "QS" j))
   ((anyp anyp  eq7p)          ("A" i t1 "SB" j)) ))
(putv code-sequencepat* 8#027 '(
   ((anyp anyp  zerop)         ("A" i t1 "ZS" j))
   ((anyp anyp  eq7p)          ("SB" j t1  "A" i )) ))
    %
(putv code-sequence*    8#030 '("A" i t1 "A" j "+A" k))
(putv code-sequencei0k* 8#030 '("A" i t1 "A" k))
(putv code-sequenceij0* 8#030 '("A" i t1 "A" j "+1"))
(putv code-sequence*    8#031 '("A" i t1 "A" j "-A" k))
(putv code-sequencepat* 8#031 '(
   ((anyp zerop zerop)         ("A" i "-1"))
   ((anyp zerop anyp)          ("A" i t1  "-A" k))
   ((anyp anyp zerop)          ("A" i t1  "A" j "-1")) ))
(putv code-sequence* 8#032 '("A" i t1 "A" j "*A" k))
(putv code-sequence* 8#034 '("B" j k    ",A" i t1    ",A0" ))
(putv code-sequence* 8#035 '(",A0" t1  "B"  j k ",A" i    ))
(putv code-sequence* 8#036 '("T" j k    ",A" i t1    ",A0" ))
(putv code-sequence* 8#037 '(",A0" t1  "T"  j k ",A" i    ))
 %
(putv code-sequence* 8#040 '("S" i t1 mem  t2 com4))
(putv code-sequence* 8#041 '("S" i t1 "-" memp1 t2 comment))
(putv code-sequence* 8#042 '("S" i t1 "#>" j k))
(putv code-sequencepat* 8#042 '(((anyp zerop zerop)("S" i t1 "-1" ))
                                ((anyp eq7p eq7p)("S" i t1 "1"))))
(putv code-sequence* 8#043 '("S" i t1 ">" j k))
(putv code-sequencepat* 8#043 '(((anyp zerop zerop)("S" i t1 "0" ))))
(putv code-sequence* 8#044 '("S" i t1 "S" j "&S" k))
(putv code-sequenceij0* 8#044 '("S" i t1 "S" j "&SB" ))
(putv code-sequence* 8#045 '("S" i t1 "#S" k "&S" j))
(putv code-sequenceij0* 8#045 '("S" i t1 "#SB&S" j ))
(putv code-sequence* 8#046 '("S" i t1 "S" j "\S" k))
(putv code-sequenceij0* 8#046 '("S" i t1 "S" j "\SB" ))
(putv code-sequencepat* 8#047 '(
   ((anyp zerop zerop)         ("S" i "#SB"))
   ((anyp zerop anyp)          ("S" i t1  "#S" k))
   ((anyp anyp zerop)          ("S" i t1  "#SB\S" j ))
   ((anyp anyp anyp )          ("S" i t1  "#S" j  "\S" k)) ))
 %
(putv code-sequence*    8#050 '("S" i t1    "S" j "!S" i "&S" k))
(putv code-sequenceij0* 8#050 '("S" i t1     "S" j "!S" i "&SB"))
(putv code-sequence*    8#051 '("S" i t1    "S" j "!S" k))
(putv code-sequencei0k* 8#051 '("S" i t1     "S" k))
(putv code-sequenceij0* 8#051 '("S" i t1     "S" j "!SB"   ))
(putv code-sequence* 8#052 '("S0"  t1    "S" i "<"  jk))
(putv code-sequence* 8#053 '("S0"  t1    "S" i ">"  jk77))
(putv code-sequence* 8#054 '("S" i  t1    "S" i "<"  jk))
(putv code-sequence* 8#055 '("S" i t1    "S" i ">"  jk77))
(putv code-sequence* 8#056 '("S" i t1    "S" i ",S" j "<A"  k))
(putv code-sequencei0k* 8#056 '("S" i t1    "S" i  "<A"  k))
(putv code-sequence* 8#057 '("S" i t1    "S" j ",S" i ">A"  k))
(putv code-sequencei0k* 8#057 '("S" i t1    "S" i  ">A"  k))
 %
(putv code-sequence* 8#060 '("S" i t1 "S" j "+S" k))
(putv code-sequence* 8#061 '("S" i t1 "S" j "-S" k))
(putv code-sequencei0k* 8#061 '("S" i t1  "-S" k))
(putv code-sequence* 8#062 '("S" i t1 "S" j "+FS" k))
(putv code-sequencei0k* 8#062 '("S" i t1  "+FS" k))
(putv code-sequence* 8#063 '("S" i t1 "S" j "-FS" k))
(putv code-sequencei0k* 8#063 '("S" i t1  "-FS" k))
(putv code-sequence* 8#064 '("S" i t1 "S" j "*FS" k))
(putv code-sequence* 8#065 '("S" i t1 "S" j "*HS" k))
(putv code-sequence* 8#066 '("S" i t1 "S" j "*RS" k))
(putv code-sequence* 8#067 '("S" i t1 "S" j "*IS" k))
 %
(putv code-sequence* 8#70 '("S" i t1 "/HS" j))
(putv code-sequencepat* 8#071
  '(((anyp zerop anyp) ("S" i t1 "A" k))
    ((anyp eq1p  anyp) ("S" i t1 "+A" k))
    ((anyp eq2p  anyp) ("S" i t1 "+FA" k))
    ((anyp eq3p  anyp) ("S" i t1 "0.6"  ))
    ((anyp eq4p  anyp) ("S" i t1 "0.4"  ))
    ((anyp eq5p  anyp) ("S" i t1 "1. "  ))
    ((anyp eq6p  anyp) ("S" i t1 "2. "  ))
    ((anyp eq7p  anyp) ("S" i t1 "4. "  )) ))
(putv code-sequencepat* 8#072
  '(((anyp zerop zerop) ("S" i t1 "RT" ))
    ((anyp zerop eq2p)  ("S" i t1 "SM" ))
    ((anyp anyp  eq3p)  ("S" i t1 "ST" j)) ))
   % single memory
(putv code-sequencepat* 8#073
  '(((anyp zerop zerop) ("S"  i  t1 "VM" ))
    ((anyp anyp  eq3p)  ("ST" j  t1 "S" i ))
    ((anyp zerop eq2p)  ("SM" t1 "S" i)) ))
(putv code-sequence* 8#074 '("S" i t1     "T" j k t2 frame))
(putv code-sequence* 8#075 '("T" j k t1     "S" i t2 frame))
(putv code-sequence* 8#076 '("S" i   t1     "V" j ",A" k ))
(putv code-sequence* 8#077 '("V" i ",A" k t1     "S" j  ))
(putv code-sequencei0k* 8#077 '("V" i ",A" k t1     "0"   ))
(putv code-sequence* 8#100 '("A" i t1 mem ",0" t2 comment))
(putv code-sequence* 8#101 '("A" i t1 mem ",A1" t2 comment))
(putv code-sequence* 8#102 '("A" i t1 mem ",A2" t2 comment))
(putv code-sequence* 8#103 '("A" i t1 mem ",A3" t2 comment))
(putv code-sequence* 8#104 '("A" i t1 mem ",A4" t2 comment))
(putv code-sequence* 8#105 '("A" i t1 mem ",A5" t2 comment))
(putv code-sequence* 8#106 '("A" i t1 mem ",A6" t2 comment))
(putv code-sequence* 8#107 '("A" i t1 mem ",A7" t2 comment))
(putv code-sequence* 8#110 '(mem ",0" t1 "A" i    t2 comment))
(putv code-sequence* 8#111 '(mem ",A1" t1 "A" i    t2 comment))
(putv code-sequence* 8#112 '(mem ",A2" t1 "A" i    t2 comment))
(putv code-sequence* 8#113 '(mem ",A3" t1 "A" i    t2 comment))
(putv code-sequence* 8#114 '(mem ",A4" t1 "A" i    t2 comment))
(putv code-sequence* 8#115 '(mem ",A5" t1 "A" i    t2 comment))
(putv code-sequence* 8#116 '(mem ",A6" t1 "A" i    t2 comment))
(putv code-sequence* 8#117 '(mem ",A7" t1 "A" i    t2 comment))
   %
(putv code-sequence* 8#120 '("S" i t1 mem ",0" t2 comment))
(putv code-sequence* 8#121 '("S" i t1 mem ",A1" t2 comment))
(putv code-sequence* 8#122 '("S" i t1 mem ",A2" t2 comment))
(putv code-sequence* 8#123 '("S" i t1 mem ",A3" t2 comment))
(putv code-sequence* 8#124 '("S" i t1 mem ",A4" t2 comment))
(putv code-sequence* 8#125 '("S" i t1 mem ",A5" t2 comment))
(putv code-sequence* 8#126 '("S" i t1 mem ",A6" t2 comment))
(putv code-sequence* 8#127 '("S" i t1 mem ",A7" t2 comment))
(putv code-sequence* 8#130 '(mem ",0" t1 "S" i    t2 comment))
(putv code-sequence* 8#131 '(mem ",A1" t1 "S" i    t2 comment))
(putv code-sequence* 8#132 '(mem ",A2" t1 "S" i    t2 comment))
(putv code-sequence* 8#133 '(mem ",A3" t1 "S" i    t2 comment))
(putv code-sequence* 8#134 '(mem ",A4" t1 "S" i    t2 comment))
(putv code-sequence* 8#135 '(mem ",A5" t1 "S" i    t2 comment))
(putv code-sequence* 8#136 '(mem ",A6" t1 "S" i    t2 comment))
(putv code-sequence* 8#137 '(mem ",A7" t1 "S" i    t2 comment))
(putv code-sequence* 8#140 '("V" i t1 "S" j "&V" k))
(putv code-sequence* 8#141 '("V" i t1 "V" j "&V" k))
(putv code-sequence* 8#142 '("V" i t1 "S" j "!V" k))
(putv code-sequencei0k* 8#142 '("V" i t1 "V" k))
(putv code-sequence* 8#143 '("V" i t1 "V" j "!V" k))
(putv code-sequence* 8#144 '("V" i t1 "S" j "\V" k))
(putv code-sequence* 8#145 '("V" i t1 "V" j "\V" k))
(putv code-sequence* 8#146 '("V" i t1 "S" j "!V" k "&VM"))
(putv code-sequencei0k* 8#146 '("V" i t1 "#VM&V" k ))
(putv code-sequence* 8#147 '("V" i t1 "V" j "!V" k "&VM"))
(putv code-sequence* 8#150 '("V" i t1 "V" j "<A" k ))
(putv code-sequenceij0* 8#150 '("V" i t1 "V" j "<1" ))
(putv code-sequence* 8#151 '("V" i t1 "V" j ">A" k ))
(putv code-sequenceij0* 8#151 '("V" i t1 "V" j ">1" ))
(putv code-sequence* 8#152 '("V" i t1 "V" j ",V" j "<A" k ))
(putv code-sequenceij0* 8#152 '("V" i t1 "V" j ",V" j "<1" ))
(putv code-sequence* 8#153 '("V" i t1 "V" j ",V" j ">A" k ))
(putv code-sequenceij0* 8#153 '("V" i t1 "V" j ",V" j ">1" ))
(putv code-sequence* 8#154 '("V" i t1 "S" j "+V" k ))
(putv code-sequence* 8#155 '("V" i t1 "V" j "+V" k ))
(putv code-sequence* 8#156 '("V" i t1 "S" j "-V" k ))
(putv code-sequencei0k* 8#156 '("V" i t1 "-V" k ))
(putv code-sequence* 8#157 '("V" i t1 "V" j "-V" k ))
(putv code-sequence* 8#160 '("V" i t1 "S" j "*FV" k ))
(putv code-sequence* 8#161 '("V" i t1 "V" j "*FV" k ))
(putv code-sequence* 8#162 '("V" i t1 "S" j "*HV" k ))
(putv code-sequence* 8#163 '("V" i t1 "V" j "*HV" k ))
(putv code-sequence* 8#164 '("V" i t1 "S" j "*RV" k ))
(putv code-sequence* 8#165 '("V" i t1 "V" j "*RV" k ))
(if_system Y-MP    % This instruction is different !!
  (putv code-sequence* 8#166 '("V" i t1 "S" j "*V" k ))
  (putv code-sequence* 8#166 '("V" i t1 "S" j "*IV" k )))
(putv code-sequence* 8#167 '("V" i t1 "V" j "*IV" k ))
(putv code-sequence* 8#170 '("V" i t1 "S" j "+FV" k ))
(putv code-sequencei0k* 8#170 '("V" i t1 "+FV" k ))
(putv code-sequence* 8#171 '("V" i t1 "V" j "+FV" k ))
(putv code-sequence* 8#172 '("V" i t1 "S" j "-FV" k ))
(putv code-sequencei0k* 8#172 '("V" i t1 "-FV" k ))
(putv code-sequence* 8#173 '("V" i t1 "V" j "-FV" k ))
(putv code-sequencepat* 8#174
  '(((anyp anyp zerop) ("V" i t1 "/HV" j))
    ((anyp anyp onep ) ("V" i t1 "PV" j))
    ((anyp anyp eq2p ) ("V" i t1 "QV" j)) ))
(putv code-sequencepat* 8#175
  '(((anyp anyp zerop) ("VM" t1 "V" j ",Z"))
    ((anyp anyp onep ) ("VM" t1 "V" j ",N"))
    ((anyp anyp eq2p ) ("VM" t1 "V" j ",P"))
    ((anyp anyp eq3p ) ("VM" t1 "V" j ",M"))
    ((anyp anyp eq4p ) ("V" i ",VM" t1 "V" j ",Z"))
    ((anyp anyp eq5p ) ("V" i ",VM" t1 "V" j ",N"))
    ((anyp anyp eq6p ) ("V" i ",VM" t1 "V" j ",P"))
    ((anyp anyp eq7p ) ("V" i ",VM" t1 "V" j ",M")) ))
%(putv code-sequence* 8#176 '("V" i t1 ",A0,A" k  t2 comment))
(putv code-sequencepat* 8#176
  '(((anyp zerop anyp) ("V" i t1 ",A0,A" k  t2  comment))
    ((anyp onep anyp)  ("V" i t1 ",A0,V" k))))
%(putv code-sequence* 8#177 '("A0,A" k  t1 "V" j    t2 comment))
(putv code-sequencepat* 8#177
  '(((zerop anyp anyp) (",A0,A" k t1 "V" j  t2  comment))
    ((onep anyp anyp)  (",A0,V" k t1 "V" j))))
 
(ds x8 (num) (safe-int2id (wplus2 48 num)))
    %
(compiletime (setq *syslisp t))
 
(de disassemble (fkt)
   (prog(base instr i j k jk jk77 p1 p2 p3 lth pat pataux
         comment mem emamem jmem mem4 symvalhigh symfnchigh frame
         argumentblockhigh labels label bstart bend breg com4 memp1)
 
         (cond ((numberp fkt) (setq base fkt))
               ((pairp fkt) (setq base (car fkt))
                            (setq bend (cadr fkt))
                            (plus2 base bend)) %do an arithmetic test
               ((idp fkt)
                      (when (not (getd fkt)) (return nil))
                      (when (not (codep (cdr (getd fkt))))(return nil))
                      (setq base (getmem (wplus2 symfnc (id2int fkt))))
                      (setq base (wand 16#FFFFFF (wrshift base 32)))
         )     )
         (when (wgreaterp (wrshift base 2) nextbps) (return nil))
         (setq argumentblockhigh (wplus2 argumentblock 15))
         (setq symvalhigh (wplus2 symval maxsymbols))
         (setq symfnchigh (wplus2 symfnc maxsymbols))
         (terpri)
         (putmem nextbps 0)            % safe endcondition
         (setq bstart base)
  % first pass: find label references
loop1
         (setq p1 (CrayGetParcel base))
         (cond((eq p1 0)(go continue1)))
         (setq instr (wrshift p1 9))      % instruction
     (if_system Y-MP  % 3-parcel instructions
         (setq lth
           (cond
             ((and (wgeq instr 8#006)(wleq instr 8#017)) 2)
             ((and (wgeq instr 8#020)(wleq instr 8#021)) 3)
             ((and (wgeq instr 8#040)(wleq instr 8#041)) 3)
             ((and (wgeq instr 8#100)(wleq instr 8#137)) 3)
             (t 1) ))
         (setq lth
           (cond
             ((and (wgeq instr 8#006)(wleq instr 8#021)) 2)
             ((and (wgeq instr 8#040)(wleq instr 8#041)) 2)
             ((and (wgeq instr 8#100)(wleq instr 8#137)) 2)
             (t 1) )))
         (setq i (wand  8#7 (wrshift p1 6)))
         (setq j (wand  8#7 (wrshift p1 3)))
         (setq k (wand  8#7 p1))
 
         (when (or (eq lth 1) (wlessp instr 8#06)
                   (wgreaterp instr 8#20))       (go next))
         (setq p2 (CrayGetParcel (wplus2 base 1)))
         (setq mem (wplus2 p2 (wlshift (wor k (wlshift j 3)) 16)))
         (if (eq instr 8#020)
            (setq jmem mem) % a register set instr for case
            (setq jmem (wplus2  mem (wlshift i 22))))% a jump address
 
         (when (eq lth 3) (setq p3 (CrayGetParcel (wplus2 base 2)))
                          (setq mem (wor mem (wlshift p3 16)))
                          (setq jmem mem)) % is reversed
 
         (setq emamem (wplus2  mem (wlshift (wand i 3) 22))) %EMA
 
         (cond ((not (assoc jmem labels))
                     (setq labels (cons (list jmem) labels)) ))
 next    (setq base (wplus2 base lth))
         (cond ((not bend ) (go loop1))
               ((wgreaterp base bend) (go continue1))
               (t (go loop1)))
 continue1
  % second pass: assign symbolic labels to jump targets
         (when (not bend) (setq bend base))
         (setq base bstart)
         (setq labels (labelsort labels))
         (mapcar labels
                (function
                  (lambda(x)
                    (cond
                      ((and       % test within-range
                        (wgeq (car x) bstart)
                        (wleq (car x) bend)
                       )(rplacd x (gensym)) )
                      (t (rplaca x nil))
         )      ) ) )
  % third pass: print instructions
         (prinbl (list "function: " fkt " base: " base))
         (terpri)
loop
         (cond ((assoc base labels)
                (tab 30) (prin2 (cdr (assoc base labels)))
                (prin2t "   =   *")))
         (setq p1 (CrayGetParcel base))
         (cond((eq p1 0)(return nil)))
         (setq instr (wrshift p1 9))      % instruction
      (if_system Y-MP  % 3-parcel instructions
         (setq lth
           (cond
             ((and (wgeq instr 8#006)(wleq instr 8#017)) 2)
             ((and (wgeq instr 8#020)(wleq instr 8#021)) 3)
             ((and (wgeq instr 8#040)(wleq instr 8#041)) 3)
             ((and (wgeq instr 8#100)(wleq instr 8#137)) 3)
             (t 1) ))
         (setq lth
           (cond
             ((and (wgeq instr 8#006)(wleq instr 8#021)) 2)
             ((and (wgeq instr 8#040)(wleq instr 8#041)) 2)
             ((and (wgeq instr 8#100)(wleq instr 8#137)) 2)
             (t 1) )))
 
         (setq i (wand  8#7 (wrshift p1 6)))
         (setq j (wand  8#7 (wrshift p1 3)))
         (setq k (wand  8#7 p1))
         (setq jk  (wor (wlshift j 3) k))
         (setq jk77 (wdifference 64 jk))
         (setq pat (IGetV code-sequence* instr))
         (cond
               ((setq pataux (IGetV code-sequencePat* instr))
                        (setq pataux (dispat pataux i j k)))
               ((eq j 0)
                        (setq pataux (IgetV code-sequencei0k* instr)))
               ((eq k 0)
                        (setq pataux (IgetV code-sequenceij0* instr)))
               (t (setq pataux nil)))
         (cond (pataux (setq pat pataux)))
         (setq breg (setq frame (wand p1 8#77)))
         (cond ((and (wgeq frame 8#30) (wleq frame 8#70))% frame range?
                (setq frame (list "frame" (wdifference frame 8#27))) )
               ((eq frame 0)(setq frame "(Reg NIL)"))
               ((eq frame 1)(setq frame "T1"))
               ((eq frame 2)(setq frame "T2"))
               ((eq frame 3)(setq frame "T3"))
               ((eq frame 4)(setq frame "T4"))
               ((eq frame 8#11)(setq frame "StackUpperBound"))
               ((eq frame 8#12)(setq frame "StackLowerBound"))
               ((eq frame 8#13)(setq frame "HeapLowerBound"))
               ((eq frame 8#14)(setq frame "HeapUpperBound"))
               ((eq frame 8#16)(setq frame "ArithArgs0"))
               ((eq frame 8#17)(setq frame "ArithArgs1"))
               ((eq frame 8#20)(setq frame "HeapTrapped"))
               ((eq frame 8#21)(setq frame "(Reg T)"))
               ((eq frame 8#22)(setq frame "Betahi*"))
               ((eq frame 8#23)(setq frame "Betalow*"))
               ((eq frame 8#24)(setq frame "CurrentScanTable"))
               ((eq frame 8#25)(setq frame "IoBuffer"))
               ((eq frame 8#26)(setq frame "PrevFrameSize"))
               ((eq frame 8#27)(setq frame "ReturnAddr"))
               (t(setq frame " ")))
         (setq breg (assoc breg '(
             (8#30 . "NextPosition")  (8#31 . "LinePosition")
             (8#32 . "WriteFunction") (8#33 . "ReadFunction")
             (8#34 . "Maxline")       (8#35 . "Chtokentype")
             (8#36 . "Currentchar")   (8#37 . "Bufferlength")
             (8#40 . "Tokch")         (8#43 . "UnreadBuffer")
             (8#44 . "Lambda-link-address") (8#45 . "CodePtr*")
             (8#46 . "Undefined-function-address")
             (8#47 . "catchstackptr")
             (8#50 . "SYMVAL")           (8#51 . "SYMFNC")
             (8#52 . "SYMPRP")           (8#53 . "SYMNAM")
             (8#54 . "StkUpbnd")         (8#55 . "HashTable")
             (8#56 . "BndstkPtr")        (8#57 . "TokenBuffer")
             (8#60 . "HeapLast")         (8#61 . "HeapTrapbound")
             (8#62 . "Bndstkupperbound") (8#63 . "ArgumentBlock")
             (8#64 . "BndStklowerbound") (8#65 . "CodeArgs")
             (8#66 . "SymCnt")           (8#67 . "LamBindArgs*")
             (8#70 . "in*")              (8#71 . "out*")
          )))
         (setq breg (if breg (cdr breg) ""))
         (tab 1)
         (prinbn base 4)
         (prin2 " ")
         (prinbn p1 6)   % binary first parcel
         (setq mem 0)
         (setq comment " ")
         (when (eq lth 1) (go single))
 
         (setq p2 (CrayGetParcel (wplus2 base 1)))
         (prin2 " ")
         (prinbn p2 6)   % binary second parcel
 
         (when (eq lth 3) (setq p3 (CrayGetParcel (wplus2 base 2)))
                          (prin2 " ") (prinbn p3 6))
                   % binary third parcel
         (setq mem (wplus2 p2 (wlshift (wor k (wlshift j 3)) 16)))
         (if (eq instr 8#020)
            (setq jmem mem) % a register set instr for case
            (setq jmem (wplus2  mem (wlshift i 22))))% a jump address
 
         (when (eq lth 3) (setq p3 (CrayGetParcel (wplus2 base 2)))
                          (setq mem (wor mem (wlshift p3 16)))
                          (setq jmem mem))
 
         (setq emamem (wplus2  mem (wlshift (wand i 3) 22))) %EMA
         (setq mem4 (wrshift jmem 2))    % parcel to word
         (setq label jmem)
         (cond
             ((and (wgeq mem argumentblock)
                   (wleq mem argumentblockhigh))
               (setq comment (list 'extrareg
                    (wplus2 (wdifference mem argumentblock) 6))) )
             ((and (wgeq mem symval)
                   (wleq mem symvalhigh))
                (setq comment (safe-int2id (wdifference mem symval))) )
             ((and (wgeq mem4 symfnc )
                   (wleq mem4 symfnchigh))
              (setq label   (safe-int2id (wdifference mem4 symfnc)))
             )
             ((assoc jmem labels)
              (setq label (cdr (assoc jmem labels))))
         )
         (if (and (wgeq (setq com4 (wrshift mem 4)) 32)
                  (wleq com4 maxsymbols))
              (setq com4 (list "'" (safe-int2id com4)))
              (setq com4 mem))
 single  (tab 32)
        (if_system Y-MP
         (when (weq (wrshift mem 31) 1) % signbit in address
                (setq mem (wor (wlshift -1 32) mem)))
         (when (weq (wrshift mem 21) 1) % signbit in address
                (setq mem (wor (wlshift -1 22) mem))))
 
         (setq memp1 (wplus2 mem 1))
         (cond ((pairp pat)
                 (prinbl
                   (subla
                     (pair
      '(  i      j      k    p2  mem jmem comment frame jk jk77
          label breg com4 memp1 emamem)
  (list (x8 i) (x8 j) (x8 k) p2  mem jmem comment frame jk jk77
          label breg com4 memp1 emamem)
                     )
                     pat
               ) ) ) )
         (terpri)
         (setq base (wplus2 base lth))
         (go loop)
)   )
 
(de dispat (pat i j k)     % pattern matcher for instruction decode
    (cond ((null pat) nil)
          ((testdispat (caar pat) i j k) (cadar pat))
          (t    (dispat (cdr pat) i j k))))
 
(de testdispat (test i j k)
    (and 
        (idapply (car test) (list i))
        (idapply (cadr test) (list j))
        (idapply (caddr test) (list k))
) )
 
(de eq1p (x) (eq x 1))
(de eq2p (x) (eq x 2))
(de eq3p (x) (eq x 3))
(de eq4p (x) (eq x 4))
(de eq5p (x) (eq x 5))
(de eq6p (x) (eq x 6))
(de eq7p (x) (eq x 7))
 
(de prinbl (l)                  % binary (octal) printing of a list
     (mapc l (function prinb)))
 
(de prinb (it)                  % binary (octal) printing of an item
     (cond ((numberp it)(prinbo it))
           ((eq it 't1) (tab 42))
           ((eq it 't2) (tab 60))
           (t       (prin2 it))))
 
(de prinbo (it)
      (cond ((wlessp it 0) (prin2 "-") (prinbo (wminus it)))
            ((wgeq it 8)  (prin2 "O'") (prinbn it 1))
            (t            (prinbn it 1))))
 
(de prinbn (it n)                % print an octal number
     (cond ((and (weq it 0) (wleq n 0)) nil)
           (t (progn
                (prinbn (wrshift it 3) (wplus2 n -1))
                (prindig (wand it 7))
)    )     )  )
 
(de prindig (dig)        % print a numeric digit
     (writeChar  (wplus2 dig 48)))
 
(de labelsort (l)        % sort labels to ascending sequence
    (labelsort1 l nil))
 
(de labelsort1 (rest sorted)
    (cond ((null rest) sorted)
          (t (labelsort1(cdr rest) (labelsortin (car rest) sorted))) ))
 
(de labelsortin (object l)
    (cond ((null l)(list object))
          ((wgreaterp (car object)(caar l))
           (cons (car l) (labelsortin object (cdr l))) )
          (t (cons object l)) ))
